(function($) {
  //$(window).on('load', function() {
    var videoLoader = function(block, video) {
      var isClass = true;

      if (block && block.length && block.hasClass('_js-video-loaded')) {
        isClass = false;
      } else {
        block.addClass('_js-video-loaded');
        block.append(video);

        block.find('video').on('loadeddata', function() {
          $(this).unbind();
          $(this).css({ opacity: 1, 'z-index': 2 });
          $(this)
            .parent()
            .find('div')
            .css('z-index', 1);
        });
      }

      return isClass;
    };

    // Video loader
    var isRedirectMobile =
      !!$('._js-blur')
        .first()
        .data('redirect-mobile') || false;

    if (
      !/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(
        navigator.userAgent
      )
    ) {
      $('.b-video-back').each(function(idx, elem) {
        var $elem = $(elem);
        var videoId = $elem.data('video-id') || 'video-rocket';
        var videoName = $elem.data('video-name') || 'anglijskij-yazyk/pegas';

        videoLoader(
          $elem,
          '<video id="' +
            videoId +
            '" class="b-volshebnica__full-screen-video" style="opacity: 0;margin-bottom: 0px; display: block;" width="100%" video autobuffer loop muted>' +
            '<source id="mp4-' +
            videoId +
            '" src="/wp-content/themes/twentyseventeen-child/assets/video/' +
            videoName +
            '.mp4" type="video/mp4">' +
            '<source id="webm-' +
            videoId +
            '" src="/wp-content/themes/twentyseventeen-child/assets/video/' +
            videoName +
            '.webm" type="video/webm">' +
            '</video>'
        );
      });
    }
    //else if (isRedirectMobile) {
    //  window.location.href = 'http://veroven.ru/dlya-mobilnih';
    //}
    // end Video loader






    function pageAnim(idx) {
      // $('#main').css('margin-bottom', 0);

      // $(window)
      //   .on('resize', function() {
      //     var winHeight = $(window).innerHeight();
      //     $parallaxDiv.css({
      //       height: winHeight,
      //     });
      //   })
      //   .trigger('resize');

      var data = {
        isMulti: idx !== null,
      };

      data.$multiArr = data.isMulti ? $('._js-multi') : null;
      data.$currentDiv = data.isMulti ? $('._js-multi').eq(idx) : $('div');
      data.$settingsDiv = data.isMulti
        ? data.$currentDiv.find('._js-blur')
        : $('._js-blur');
      data.$currentBack = data.isMulti
        ? data.$currentDiv.find('.b-video-back')
        : $('.b-video-back');
      data.$currentBlurBack = data.isMulti
        ? data.$currentDiv.find('._js-blur-back')
        : $('._js-blur-back');
      data.$elemAnim = data.isMulti
        ? data.$currentDiv.find('._js-span-anim-roll')
        : $('._js-span-anim-roll');

      console.log(data);

      return $
        .Deferred()
        .resolve()
        .then(function() {
          if (data.$currentDiv.hasClass('_js-modal-full-area')) {
            var mouseY = null;

            $(window).on('mousemove', function(event) {
              var mouseWindowY = event.pageY - $(window).scrollTop();

              if (mouseY >= 0 && mouseY > mouseWindowY && mouseWindowY < 50) {
                $(window).off('mousemove');
                data.$currentDiv.find('._js-modal-full-area').css({
                  opacity: 1,
                  display: 'block',
                });
              }

              mouseY = mouseWindowY;
            });
          }
        })
        .then(function() {
          var link = data.$settingsDiv.data('redirect-link');
          var redirectDelay =
            data.$settingsDiv.data('redirect-delay') * 1000 || 0;
          var isRedirectBack = data.$settingsDiv.data('redirect-back');

          if (isRedirectBack) {
            link = document.referrer;
          }

          if (link && link.length) {
            setTimeout(function() {
              window.location.href = link;
            }, redirectDelay);
          }
        })
        .then(function() {
          var videoId =
            data.$currentBack.first().data('video-id') || 'video-rocket';
          var myVideo = document.getElementById(videoId);

          if (myVideo) {
            var start = data.$currentBack.first().data('video-start') || 5.2;
            var delay =
              data.$currentBack.first().data('video-start-delay') || 10;

            myVideo.currentTime = start;

            setTimeout(function() {
              myVideo.play();
            }, delay);
          }

          return true;
        })
        .then(function() {
          var delayEarlyBlur =
            data.$currentBlurBack.first().data('early-blur-delay') * 1000 || 0;

          if (delayEarlyBlur) {
            data.$currentBlurBack.velocity(
              { opacity: 1 },
              { duration: 1000, delay: delayEarlyBlur }
            );
          }
        })
        .then(function() {
          var dfd = $.Deferred();
          var delayAnim =
            data.$currentBlurBack.first().data('anim-delay') * 1000 ||
            data.$currentBack.first().data('anim-delay') * 1000 ||
            0;

          setTimeout(function() {
            dfd.resolve();
          }, delayAnim);

          return dfd.promise();
        })
        .then(function animateText() {
          var dfd;
          var $elements = data.$elemAnim;

          if ($elements && $elements.length) {
            dfd = $elements.toArray().reduce(function(val, curr, ind, arr) {
              var result = $.Deferred();

              val.then(function() {
                var $element = $(arr[ind]);
                var $childElem = $element.find('span');
                var speed = $element.data('speed') * 1000 || 700;

                if ($element.hasClass('_anim-no-delay')) {
                  result.resolve();
                }

                if ($element.hasClass('_anim-scale')) {
                  $childElem.css({
                    transform: 'scale(1)',
                    opacity: 1,
                  });

                  setTimeout(function() {
                    result.resolve();
                  }, speed);
                } else if ($element.hasClass('_anim-opacity')) {
                  var delay = $element.data('elem-anim-delay') * 1000 || 0;

                  $childElem.velocity(
                    {
                      opacity: 1,
                    },
                    {
                      duration: speed,
                      delay: delay,
                      complete: function() {
                        result.resolve();
                      },
                    }
                  );
                } else {
                  var elemWidth = $element.css('width');
                  var animeDelay = $element.data('delay') * 1000 || 0;
                  var speedCoef = $element.data('speed-coef') || 1;
                  var rollSpeed = 400 * speedCoef;

                  var animTime = Math.round(
                    (parseInt(elemWidth, 10) / rollSpeed) * 1000
                  );

                  $element.css('width', elemWidth);
                  $childElem.css({
                    width: 0,
                    opacity: 1,
                  });

                  $childElem.velocity(
                    { width: elemWidth },
                    {
                      duration: animTime,
                      delay: animeDelay,
                      complete: function() {
                        result.resolve();
                      },
                    }
                  );
                }
              });

              return result.promise();
            }, $.Deferred().resolve());
          }

          return dfd;
        })
        .then(function() {
          var dfd = $.Deferred();
          var delayEarlyBlur =
            data.$currentBlurBack.first().data('early-blur-delay') * 1000 || 0;
          var isDisappearBlur =
            data.$currentBlurBack.first().data('disappear-blur') || false;
          var isBlurBack = data.$currentBlurBack.length;

          if (isBlurBack && !delayEarlyBlur && !isDisappearBlur) {
            var blurDelay =
              data.$currentBlurBack.first().data('blur-delay') * 1000 || 4000;

            data.$currentBlurBack.velocity(
              { opacity: 1 },
              {
                duration: 1000,
                delay: blurDelay,
                complete: function() {
                  dfd.resolve();
                },
              }
            );
          } else if (isBlurBack && isDisappearBlur) {
            var isDisappearText =
              data.$currentBlurBack.first().data('disappear-text') || false;

            if (isDisappearText) {
              data.$currentDiv.find('._js-disappear-text').velocity(
                { opacity: 0 },
                {
                  duration: 1000,
                  delay: 0,
                }
              );
            }

            data.$currentBlurBack.velocity(
              { opacity: 0 },
              {
                duration: 1000,
                delay: 0,
                complete: function() {
                  dfd.resolve();
                },
              }
            );
          } else {
            dfd.resolve();
          }

          return dfd.promise();
        })
        .then(function() {
          var dfd = $.Deferred();

          $elems = data.$currentDiv.find('._js-blur-opacity');

          if ($elems && $elems.length) {
            $elems.velocity({ opacity: 1 }, 1000, function() {
              dfd.resolve();
            });
          } else {
            dfd.resolve();
          }

          return dfd.promise();
        })
        .then(function() {
          var dfd = $.Deferred();
          var isDisappear = data.$currentDiv.data('disappear');

          if (data.isMulti && data.$currentDiv.length && isDisappear) {
            var delay = data.$currentDiv.data('disappear-delay') * 1000 || 0;

            data.$currentDiv.velocity(
              { opacity: 0 },
              {
                duration: 1000,
                delay: delay,
                display: 'none',
                complete: function() {
                  dfd.resolve();
                },
              }
            );
          } else {
            dfd.resolve();
          }

          return dfd.promise();
        })
        .then(function() {
          var dfd = $.Deferred();
          var isDisappearLink =
            data.$currentDiv.data('disappear-link') || false;

          if (
            data.isMulti &&
            data.$currentDiv.length &&
            isDisappearLink &&
            data.$multiArr.length - 1 > idx
          ) {
            data.$currentDiv.find('._js-multi-next').on('click', function(e) {
              e.preventDefault();

              data.$currentDiv.velocity(
                { opacity: 0 },
                {
                  duration: 1000,
                  display: 'none',
                  complete: function() {
                    dfd.resolve();
                  },
                }
              );
            });
          } else {
            dfd.resolve();
          }

          return dfd.promise();
        });
      // .then(function() {
      //   var elements = $('._js-king p').toArray();
      //   console.log(elements)

      //   elements.reduce(function(acc, curr, ind, arr) {
      //     console.log('elements')
      //     var newDfd = $.Deferred();

      //     acc.then(function() {
      //       console.log($(arr[ind]))
      //       $(arr[ind]).velocity({opacity: 0}, {
      //         duration: 1000,
      //         delay: 2000
      //       });

      //       $(arr[ind + 1]).velocity({opacity: 1}, {
      //         duration: 1000,
      //         delay: 3000,
      //         complete: function() { newDfd.resolve() }
      //       });
      //     })

      //     return newDfd.promise();
      //   }, $.Deferred().resolve())
      // })
    }

    var isPageAnim = $('div').hasClass('_js-blur');
    var $multi = $('._js-multi');
    var isMultiAnim = $multi.length;

    if (isPageAnim && isMultiAnim) {
      $multi.toArray().reduce(function(res, curr, idx) {
        return res.then(function() {
          return pageAnim(idx);
        });
      }, $.Deferred().resolve());
    } else if (isPageAnim) {
      pageAnim(null);
    }

    // $('._js-multi-next').on('click', function(e) {
    //   e.preventDefault();
    //   console.log(e.currentTarget.data())
    // });
  //});
})(jQuery);
